<?php

	if(EZ_FEEDS_BACK_UP_TYPE == TEXT_EXPORT_DATAFEED) {

    set_time_limit(0);

    $location = DIR_EZ_FEEDS_BACKUPS . EZ_FEEDS_EXPORT_FOLDER_PATH . 'datafeed.txt'; //used in 3 places

    if (file_exists($location)) {
        unlink($location);
    }

    $db->execute("DROP TABLE IF EXISTS  `build_datafeed`");
     
    $db->execute("CREATE TABLE `build_datafeed`(
				`pID` INT(11) AUTO_INCREMENT,
				`mfg` VARCHAR(64) NULL DEFAULT NULL,
				`sku` VARCHAR(64) NULL DEFAULT NULL,
				`model` VARCHAR(64) NULL DEFAULT NULL,
				`name` VARCHAR(640) NOT NULL DEFAULT '',
				`desc` TEXT NULL DEFAULT NULL,
				`img` TEXT NULL DEFAULT NULL,
				`weight` FLOAT NOT NULL DEFAULT '0',
				`cost` DECIMAL(15, 2) NOT NULL DEFAULT '0.00',
				`map` DECIMAL(15, 2) NOT NULL DEFAULT '0.00',
				`msrp` DECIMAL(15, 2) NOT NULL DEFAULT '0.00',
				`shipping` VARCHAR(32) NULL DEFAULT '',
				`zip` VARCHAR(10) NULL DEFAULT NULL,
				`qty` FLOAT NOT NULL DEFAULT '0',
				`tags` TEXT NULL DEFAULT NULL,
				`length` VARCHAR(32) NULL DEFAULT '',
				`height` VARCHAR(32) NULL DEFAULT '',
				`width` VARCHAR(32) NULL DEFAULT '',
				`pqty` FLOAT NOT NULL DEFAULT '1',
				`cat` VARCHAR(64) NULL DEFAULT NULL,
				`catpath` TEXT NULL DEFAULT NULL,
				`added` DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
				`freq` VARCHAR(64) NULL DEFAULT NULL,
				`lead` VARCHAR(64) NULL DEFAULT NULL,
				`eta` VARCHAR(64) NULL DEFAULT NULL,
				`updated` DATETIME NOT NULL DEFAULT CURRENT_TIMESTAMP,
				`url` TEXT NULL DEFAULT NULL,
				PRIMARY KEY(`pID`)
		) ENGINE = MyISAM AS SELECT
    `p`.`products_id` AS `pID`,
    `m`.`manufacturers_name` AS `mfg`,
    `p`.`products_model` AS `sku`,
    SUBSTR(`p`.`products_model`, 2) AS `model`,
    `pd`.`products_name` AS `name`,
    SUBSTRING_INDEX(
    REPLACE
        (
        REPLACE
            (
                `pd`.`products_description`,
                '<b>Featured Product! </b><br />',
                ''
            ),
            'Best Seller!<br><br>',
            ''
    ),
    '<br /><br />Model - ',
    1
) AS `desc`,
`p`.`products_image` AS `img`,
`p`.`products_weight` AS `weight`,
`p`.`products_price` * 0.75 AS `cost`,
IF(
    `pd`.`products_description` LIKE '%MAP Price Required%',
    `p`.`products_price`,
    ''
) AS `map`,
`p`.`products_price` AS `msrp`,
CASE WHEN `p`.`ship_method` = 'UPS Rates' THEN 'UPS Shipping' WHEN `p`.`ship_method` = 'FedEx Rates' THEN 'FedEx Shipping' WHEN `p`.`ship_method` = 'Free Shipping' THEN 'Free Shipping' WHEN `p`.`ship_method` LIKE 'Free Shipping (Store Pays Entire Flat Rate: %' THEN
REPLACE
    (
        `p`.`ship_method`,
        'Free Shipping (Store Pays Entire Flat Rate: ',
        ''
    ) WHEN `p`.`ship_method` LIKE 'Partially Free Shipping: (Store Pays%' THEN SUBSTRING_INDEX(
    REPLACE
        (
            `p`.`ship_method`,
            ' Shipping Cost!)',
            ''
        ),
        ' of ',
        -1
) ELSE ''
END AS `shipping`,
`p`.`ship_zip` AS `zip`,
`p`.`products_quantity` AS `qty`,
SUBSTRING_INDEX(
    SUBSTRING_INDEX(
    REPLACE
        (
            `pd`.`products_description`,
            '<a href=index.php?main_page=page&id=21>MAP Price Required, </a>',
            'MAP Price Required, '
        ),
        'Notes - ',
        -1
),
'<br /><br />',
1
) AS `tags`,
'' AS `length`,
'' AS `height`,
'' AS `width`,
`p`.`products_quantity_order_units` AS `pqty`,
`cd`.`categories_name` AS `cat`,
`cd`.`categories_id` AS `catpath`,
`p`.`products_date_added` AS `added`,
'' AS `freq`,
'' AS `lead`,
`p`.`products_date_available` AS `eta`,
`p`.`products_last_modified` AS `updated`,
'' AS `url`
FROM `products` `p`
INNER JOIN categories_description cd ON `p`.`master_categories_id` = `cd`.`categories_id`
INNER JOIN products_description pd ON `p`.`products_id` = `pd`.`products_id`
INNER JOIN manufacturers m ON `p`.`manufacturers_id` = `m`.`manufacturers_id`
INNER JOIN `categories` `c` ON `p`.`master_categories_id` = `c`.`categories_id`

"); //LIMIT 1000
   
$db->execute("UPDATE `build_datafeed` SET `lead` = '30 Days' WHERE `desc` LIKE '%allow 30 days%'");

$db->execute("UPDATE `build_datafeed` SET `lead` = '14-21 Days' WHERE `desc` LIKE '%allow 14-21 days%' OR `desc` LIKE '%ALLOW 2 TO 3 WEEKS%'");

$db->execute("UPDATE `build_datafeed` SET `freq` = '7 Days' WHERE `freq` = ''");

$db->execute("UPDATE `build_datafeed` SET `length` = '7 Days' WHERE `freq` = ''");

$db->execute(" UPDATE `build_datafeed` SET `tags` = CONCAT('FedEx Shipping, ', `tags`) WHERE `shipping` LIKE '%FedEx%' AND `tags` NOT LIKE '%FedEx %' ");
$db->execute(" UPDATE `build_datafeed` SET `tags` = CONCAT('UPS Shipping, ', `tags`) WHERE `shipping` LIKE '%UPS%' AND `tags` NOT LIKE '%UPS %' ");
$db->execute(" UPDATE `build_datafeed` SET `tags` = CONCAT('Free Shipping, ', `tags`) WHERE `shipping` LIKE '%Free%' AND `tags` NOT LIKE '%Free %' ");
$db->execute(" UPDATE `build_datafeed` SET `tags` = CONCAT('FlatRate Shipping, ', `tags`) WHERE `shipping` > 0 AND `tags` NOT LIKE '%FlatRate %' ");

$db->execute(" UPDATE `build_datafeed` SET `shipping` = 'FedEx' WHERE `shipping` = '' AND `tags` like '%FedEx %' AND `shipping` = '' ");
$db->execute(" UPDATE `build_datafeed` SET `shipping` = 'UPS' WHERE `shipping` = '' AND `tags` like '%UPS %'  AND `shipping` = '' ");
$db->execute(" UPDATE `build_datafeed` SET `shipping` = 'FREE' WHERE `shipping` = '' AND `tags` like '%Free %'  AND `shipping` = '' ");

$db->execute("UPDATE `build_datafeed` SET `length` = SUBSTRING_INDEX(`desc`, 'Shipping Dimensions: ', -1), `width` =  SUBSTRING_INDEX(`desc`, 'Shipping Dimensions: ', -1), `height` = SUBSTRING_INDEX(`desc`, 'Shipping Dimensions: ', -1) WHERE 
`desc` LIKE '%Shipping Dimensions: %'");
$db->execute("UPDATE `build_datafeed` SET `length` = SUBSTRING_INDEX(`length`, 'x', 1) WHERE `length` != ''");
$db->execute("UPDATE `build_datafeed` SET `width` = SUBSTRING_INDEX(`width`, 'x', -2) WHERE `width` != ''");
$db->execute("UPDATE `build_datafeed` SET `width` = SUBSTRING_INDEX(`width`, 'x', 1) WHERE `width` != ''");
$db->execute("UPDATE `build_datafeed` SET `height` = SUBSTRING_INDEX(`height`, 'x', -1) WHERE `height` != ''");

$db->execute("UPDATE `build_datafeed` SET `eta` = '' WHERE `eta` = '0000-00-00 00:00:00' OR `eta` < NOW() OR `eta` IS NULL");

$categoryID = $db->execute(" SELECT DISTINCT `catpath` FROM `build_datafeed` ");
foreach($categoryID as $data) {
    $full_path = zen_output_generated_category_path($categoryID->fields['catpath']);
    $full_path = str_replace('&nbsp;&gt;&nbsp;', '>', $full_path);
		$db->execute("UPDATE `build_datafeed` SET `catpath` = '$full_path' WHERE `catpath` = " . $categoryID->fields['catpath']);
}

$db->execute(" UPDATE `build_datafeed` SET `url` = CONCAT('http', SUBSTRING_INDEX(`desc`,'http',-1)) WHERE `desc` LIKE '%http%' AND (`desc` LIKE '%.com%' OR `desc` LIKE '%.org%' OR `desc` LIKE '%.biz%') ");

$db->execute("UPDATE `build_datafeed` SET `url` = CONCAT(SUBSTRING_INDEX(`url`,'.com',1), '.com') WHERE `url` LIKE '%.com%' AND `url` NOT LIKE '%.com/%'");

$db->execute("UPDATE `build_datafeed` SET `url` = SUBSTRING_INDEX(`url`,' ',1) WHERE `url` LIKE '%.com/%'");

$db->execute("UPDATE `build_datafeed` SET `url` = CONCAT(SUBSTRING_INDEX(`url`,'.pdf',1), '.pdf') WHERE `url` LIKE '%.pdf%'");

$db->execute("UPDATE `build_datafeed` SET `desc` = SUBSTRING_INDEX(`desc`,'<br /><br />Conditon - ',1) WHERE `desc` LIKE '%<br /><br />Conditon - %'");

//ADD SPACE BEFORE EACH ITEM IN ARRAY - Add aplphabeticvally and single words must be at the end when contained in any phrase in the array
$put_space_before = ['Additional Details', 'Adjustable harness ', 'Application: ', 'Assembly: ', 'Aurora gauges offers', 'Available in',  'Best gift for',  'Boxed Weight: ', 'Bushing Material: ', 'Choose from several colors', 'Custom Etch Patterns Available: ', 'Design Color: ', 'Designed in the USA', 'Detailed Instructions', 'Dim Weight: ', 'Durable', 'Emblem: ', 'FANMATS Series', 'Featured on several', 'Featured on several', 'Features and Specifications: ', 'Finish: ', 'Fits: ', 'Fits Fuel Level Face: ', 'Fits Oil Pressure Face: ', 'Fits Speedometer: ', 'Fits Tachometer Face: ', 'Fits Turbo Boost Face: ', 'Fits Volt Face: ', 'Fits Water Temp Face: ', 'Flange Width ', 'Four Heavy Duty', 'Free Tech Support', 'Fully Adjustable', 'Gauge ID: ', 'Gauge OD: ', 'Harness: ', 'Height: ', 'Hydration Bladder', 'Hydration system ', 'IMPORTANT NOTE: ', 'Interchangeable Faces: ', 'It has ', 'It is ', 'Fuse: ', 'Industry Leading Accuracy', 'Interchangeable Needles: ', 'Interchangeable Trim Ring: ', 'Keep It Clean ', 'King Pin: ', 'Large Ring OD: ', 'Leads: ', 'Length: ', 'Leash: ', 'Limited Lifetime Warranty', 'Lincoln Navigator ', 'Made of', 'Minimum Length ', 'Mounting Bracket: ', 'Mounting holes: ', 'Needle Color: ', 'Needle Series: ', 'Number Of ', 'One Belly Pouch', 'Outside Diameter ', 'Oversized Shipping Reference: ', 'Package Dimensions: ', 'PALS webbing', 'Perfect gift', 'Perfect for', 'Perfect toy for', 'Please note: ', 'Product Dimensions', 'Qty: ', 'Quick Detach Buckles', 'Shea Butter is known', 'Shift Knobs Color: ', 'Shims: ', 'Shims Material: ', 'Shoulder MOLLE ', 'Six Double AR', 'Special Shipping Note', 'Stepper Motor Accurancy', 'Sensor: ', 'Shipping Dimensions', 'Size: ', 'Split design', 'Style: ', 'SUPPORTED VEHICLE MAKE/MODEL', 'Team Series', 'The legs are', 'The soft noodle', 'These long ', 'This ', 'Trim Ring Series: ', 'Toll Free Tech Support', 'Free Tech Support', 'The fur mouse', 'Two Gear Pouches', 'Unit Of Measure: ', 'Water Temp Range: ', 'Weight:', 'Whether in water', 'Width: ', 'You can ', 'Your dog ', 'Your four legged', 'Adjustable', 'Color: ', 'Diameter: ', 'Features:', 'Feature:', 'Material:'];
foreach($put_space_before as $string) {
    $db->execute(" UPDATE `build_datafeed` SET `desc` = REPLACE(`desc`, '$string', ' $string') WHERE `desc` like '%$string%' ");
}


//SELECT * FROM `build_datafeed` WHERE `desc` REGEXP '\\.[A-Z]' 



//ADD SPACE AFTER EACH ITEM IN THE ARRAY
$put_space_after = ['SUPPORTED VEHICLE MAKE/MODEL(S)'];
foreach($put_space_before as $string) {
    $db->execute(" UPDATE `build_datafeed` SET `desc` = REPLACE(`desc`, '$string', '$string ') WHERE `desc` like '%$string%' ");
}

//REMOVE DOUBLE SPACES THAT MIGHT HAVE BEEN CREATED IN LAST STEP
$i = 0;
do {
    $db->execute(" UPDATE `build_datafeed` SET `desc` = REPLACE(`desc`, '  ', ' ') WHERE `desc` like '%  %' ");
    $i++;
} while($i < 5);

$db->execute(" UPDATE `build_datafeed` SET `desc` = REPLACE(`desc`, '\'\'', '\\"') WHERE `desc` like '%\'\'%' ");

$db->execute("SELECT 'pID', 'mfg', 'sku', 'model', 'name', 'desc', 'img', 'weight', 'cost', 'map', 'msrp', 'shipping', 'zip', 'qty', 'tags', 'length', 'height', 'width', 'pqty', 'cat', 'catpath', 'added', 'freq', 'lead', 'eta', 'updated', 'url'
UNION SELECT `pID`, `mfg`, `sku`, `model`, `name`, `desc`, `img`, `weight`, `cost`, `map`, `msrp`, `shipping`, `zip`, `qty`, `tags`, `length`, `height`, `width`, `pqty`, `cat`, `catpath`, `added`, `freq`, `lead`, `eta`, `updated`, `url` 
FROM `build_datafeed` INTO OUTFILE '$location' FIELDS TERMINATED BY '\t' ENCLOSED BY '\"' LINES TERMINATED BY '\n'");

$messageStack->add_session(SUCCESS_DATAFEED_EXPORT_COMPLETE . $location, TEXT_SUCCESS);	
}
?>